VERSION 5.00
Begin VB.UserControl XDataControl 
   ClientHeight    =   495
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4485
   ScaleHeight     =   495
   ScaleWidth      =   4485
   ToolboxBitmap   =   "XDataControl.ctx":0000
   Begin VB.CommandButton BFirst 
      Enabled         =   0   'False
      Height          =   495
      Left            =   0
      Picture         =   "XDataControl.ctx":0312
      Style           =   1  'Grafisch
      TabIndex        =   8
      TabStop         =   0   'False
      ToolTipText     =   "Erster Datensatz"
      Top             =   0
      Width           =   495
   End
   Begin VB.CommandButton BPrevious 
      Enabled         =   0   'False
      Height          =   495
      Left            =   480
      Picture         =   "XDataControl.ctx":0C40
      Style           =   1  'Grafisch
      TabIndex        =   7
      TabStop         =   0   'False
      ToolTipText     =   "Vorhergehender Datensatz"
      Top             =   0
      Width           =   495
   End
   Begin VB.CommandButton BNext 
      Enabled         =   0   'False
      Height          =   495
      Left            =   960
      Picture         =   "XDataControl.ctx":156E
      Style           =   1  'Grafisch
      TabIndex        =   6
      TabStop         =   0   'False
      ToolTipText     =   "Nchster Datensatz"
      Top             =   0
      Width           =   495
   End
   Begin VB.CommandButton BLast 
      Enabled         =   0   'False
      Height          =   495
      Left            =   1440
      Picture         =   "XDataControl.ctx":1E9C
      Style           =   1  'Grafisch
      TabIndex        =   5
      TabStop         =   0   'False
      ToolTipText     =   "Letzter Datensatz"
      Top             =   0
      Width           =   495
   End
   Begin VB.CommandButton BInsert 
      Enabled         =   0   'False
      Height          =   495
      Left            =   1920
      Picture         =   "XDataControl.ctx":27CA
      Style           =   1  'Grafisch
      TabIndex        =   4
      TabStop         =   0   'False
      ToolTipText     =   "Datensatz einfgen"
      Top             =   0
      Width           =   495
   End
   Begin VB.CommandButton BEdit 
      Enabled         =   0   'False
      Height          =   495
      Left            =   2400
      Picture         =   "XDataControl.ctx":30F8
      Style           =   1  'Grafisch
      TabIndex        =   3
      TabStop         =   0   'False
      ToolTipText     =   "Datensatz Editieren"
      Top             =   0
      Width           =   495
   End
   Begin VB.CommandButton BCancel 
      Enabled         =   0   'False
      Height          =   495
      Left            =   2880
      Picture         =   "XDataControl.ctx":3A26
      Style           =   1  'Grafisch
      TabIndex        =   2
      TabStop         =   0   'False
      ToolTipText     =   "nderungen verwerfen"
      Top             =   0
      Width           =   495
   End
   Begin VB.CommandButton BSave 
      Enabled         =   0   'False
      Height          =   495
      Left            =   3360
      Picture         =   "XDataControl.ctx":4354
      Style           =   1  'Grafisch
      TabIndex        =   1
      TabStop         =   0   'False
      ToolTipText     =   "nderungen Sichern"
      Top             =   0
      Width           =   495
   End
   Begin VB.CommandButton BDelete 
      Enabled         =   0   'False
      Height          =   495
      Left            =   3840
      Picture         =   "XDataControl.ctx":4C82
      Style           =   1  'Grafisch
      TabIndex        =   0
      TabStop         =   0   'False
      ToolTipText     =   "Datensatz Lschen"
      Top             =   0
      Width           =   495
   End
End
Attribute VB_Name = "XDataControl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' Wechsel des aktuellen Datensatzes anzeigen
Public Event Current()
' Abfrage, ob der Datensatz gelscht werden soll
Public Event ConfirmDelete(ByRef cancel As Boolean)
' Klick auf die Edit-Taste
Public Event EditClick()
' Klick auf die Cancel-Taste
Public Event CancelClick()
' Klick auf die Update-Taste
Public Event UpdateClick()
' Klick auf die Insert-Taste
Public Event InsertClick()

Private DelbuttonShow As Boolean

Private rs As Recordset

Public Property Get Recordset() As Recordset
    Set Recordset = rs
End Property

Public Property Set Recordset(ByVal vNewValue As Recordset)
On Error Resume Next
    Set rs = vNewValue
    TastenSperren
    RaiseEvent Current
End Property


Private Sub UserControl_InitProperties()
  DelbuttonShow = True
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
 DelbuttonShow = PropBag.ReadProperty("ShowDeleteButton")
  ShowDeleteButton = DelbuttonShow
End Sub

Private Sub UserControl_Resize()
 On Error Resume Next
 UserControl.Height = 495    ' Twips !!!
 UserControl.Width = 4455    ' Twips !!!
End Sub

Public Property Get ShowDeleteButton() As Variant
 ShowDeleteButton = DelbuttonShow
End Property

Public Property Let ShowDeleteButton(ByVal vNewValue As Variant)
 DelbuttonShow = vNewValue
 BDelete.Visible = vNewValue
 PropertyChanged "ShowDeleteButton"
End Property

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
 PropBag.WriteProperty "ShowDeleteButton", DelbuttonShow
End Sub

Private Sub TastenSperren()
    If rs.EditMode = dbEditNone Then
        BInsert.Enabled = rs.Updatable
        BEdit.Enabled = rs.Updatable
        BDelete.Enabled = rs.Updatable
        BCancel.Enabled = False
        BSave.Enabled = False
        If rs.Type = dbOpenForwardOnly Then
            BPrevious.Enabled = False
            BFirst.Enabled = False
            BLast.Enabled = False
        Else
            BPrevious.Enabled = True
            BFirst.Enabled = True
            BLast.Enabled = True
        End If
        BNext.Enabled = True
    Else
        BInsert.Enabled = False
        BEdit.Enabled = False
        BDelete.Enabled = False
        BCancel.Enabled = True
        BSave.Enabled = True
        BPrevious.Enabled = False
        BFirst.Enabled = False
        BNext.Enabled = False
        BLast.Enabled = False
    End If
End Sub

Private Sub BDelete_Click()
Dim bbCancel As Boolean

If IsEmpty(rs) Then Exit Sub

    bbCancel = False
    RaiseEvent ConfirmDelete(bbCancel)
    If Not bbCancel Then  ' Lschen Datensatz
        If Not (rs.BOF And rs.EOF) Then rs.Delete
        rs.MoveNext
        If rs.EOF Then rs.MoveLast
        RaiseEvent Current
    End If
End Sub

Private Sub BEdit_Click()
    If IsEmpty(rs) Then Exit Sub
    rs.Edit
    TastenSperren
    RaiseEvent EditClick
End Sub

Private Sub BFirst_Click()
    If IsEmpty(rs) Then Exit Sub
    rs.MoveFirst
    RaiseEvent Current
End Sub

Private Sub BInsert_Click()
    If IsEmpty(rs) Then Exit Sub
    rs.AddNew
    TastenSperren
    RaiseEvent InsertClick
End Sub

Private Sub BLast_Click()
    If IsEmpty(rs) Then Exit Sub
    rs.MoveLast
    RaiseEvent Current
End Sub

Private Sub BNext_Click()
    If IsEmpty(rs) Then Exit Sub
    rs.MoveNext
    If rs.EOF Then rs.MoveLast
    RaiseEvent Current
End Sub

Private Sub BPrevious_Click()
    If IsEmpty(rs) Then Exit Sub
    rs.MovePrevious
    If rs.BOF Then rs.MoveFirst
    RaiseEvent Current
End Sub

Private Sub BSave_Click()
    If IsEmpty(rs) Then Exit Sub
    RaiseEvent UpdateClick
    rs.Update
    TastenSperren
    RaiseEvent Current
End Sub

